.table {
    font-size: inherit;
    display: flex;
    flex-direction: column;

    &.font-small {
        font-size: $font-size-small;
    }

    .header {
        @extend .row;

        color: $grey-700;
        align-items: center;

        .cell {
            display: inline-flex;
            align-items: center;

            svg {
                flex-shrink: 0;
            }
        }
    }

    .row {
        display: flex;
        flex-direction: row;
        flex-wrap: nowrap;

        &.valign__center {
            align-items: center;
        }

        .cell {
            display: flex;
            flex-grow: 1;
            @include padding(3, 3);

            &.colspan-auto {
                width: auto;
                flex-basis: auto;
                flex-grow: 0;
            }

            &.valign__center {
                align-items: center;
            }

            &.valign__top {
                align-self: flex-start;
            }

            &.align__right {
                justify-content: flex-end;
                text-align: right;
            }

            &.align__center {
                justify-content: center;
                text-align: center;
            }

            &.nowrap {
                overflow: hidden;
                white-space: nowrap;
                text-overflow: ellipsis;
            }

            &.wrap {
                flex-wrap: wrap;
            }

            &.actions {
                display: flex;
                justify-content: flex-end;
                flex-direction: row;
                flex-wrap: nowrap;
                //align-items: center;
                //flex-shrink: 1;
                flex-grow: 0;
                width: auto;
                flex-basis: auto;
            }
        }
    }
}

@mixin tableCell() {
    @for $cell from 2 through 24 {
        .cells#{$cell} {
            .cell {
                //flex-basis: #{(100 / $cell) * 1%};
                //width: #{(100 / $cell) * 1%};
                flex-basis: calc(100% / #{$cell});
                width: calc(100% / #{$cell});

                @for $span from 2 through 12 {
                    &.colspan-#{$span} {
                        //flex-basis: #{(100 / $cell) * 1% * $span};
                        //width: #{(100 / $cell) * 1% * $span};
                        flex-basis: calc((100% / #{$cell}) * #{$span});
                        width: calc((100% / #{$cell}) * #{$span});
                    }
                }
            }
        }
    }
}

@include tableCell;

@mixin action() {
    // size of one Button Icon
    $iconSize: 2.1;

    @for $span from 1 through 5 {
        .action#{$span} {
            flex-basis: #{($span * $iconSize) + 1}rem !important;
            width: #{($span * $iconSize) + 1}rem !important;
        }
    }
}

@include action;
